package mobicomp.util;

import java.util.Observable;

/**
 * UPDATE: Starting a new Thread for each object which must be
 * dispatched.
 *  
 * @author Andreas Wetzel <andi@spamato.net>
 * Last Update 8.1.2005 Nicolas
 */
public class Dispatcher extends Observable
{
    public void dispatch( Object obj) {
        
        // you have to call setChanged before every notify, otherwise
        // the notify does not call its observers
        setChanged();
                
        new DispatcherThread(this,obj).start();
        // notifyObservers( obj);
    }
}

class DispatcherThread extends Thread{
	
	Dispatcher dispatcher;
	Object o;
	
	public DispatcherThread(Dispatcher dis, Object o){
		this.dispatcher = dis;
		this.o = o;
	}
	
	public void  run(){
		dispatcher.notifyObservers(o);
	}
	
}
